/************************************************************************
*   ACCESS SAMPLE PROGRAM                                               *
*                                                              BY CAD'S *
*                                                                       *
*       The program of erasing elements (Batch mode)                    *
*                                                                       *
************************************************************************/
#include    <string.h>
#include    <stdio.h>
#include    <stdlib.h>
#include    <memory.h>
#include    <ctype.h>
#define     VOL_4                       /* Drive is 4 characters */
#include    "accfnc.h"
#include    "accarg.h"

extern short erselm(long,long,char*,char*,char*,char*);
extern short logfopen(char*);
extern short logmsg(long);
extern void  logfclse(void);

#define FALSE                   0
#define TRUE                    1

#define SPACE_CHAR            ' '

#define VOL_LEN                 4
#define GROUP_LEN               4
#define USER_LEN                6
#define DWGID_LEN              20
#define DWG_LEN                27
#define ID_LEN                  8
#define CHKLEN                100

#define INVALID_PARA                      1
#define INVALID_PARA_FROM                11
#define INVALID_PARA_FROM_UNDEFINED      12
#define INVALID_PARA_DWG                 21
#define INVALID_PARA_DWG_UNDEFINED       22
#define INVALID_PARA_ID                  31
#define INVALID_PARA_ID_UNDEFINED        32
#define INVALID_PARA_TYPE                41
#define INVALID_PARA_TYPE_UNDEFINED      42
#define INVALID_PARA_SHO                 51
#define INVALID_PARA_SHO_UNDEFINED       52
#define INVALID_PARA_MSG                 61

static  int chkpara(char*,char*,char*,char*);
static  int brkpara(char*,char*,char*,char*);
static  int brkpara_id(char*,char*,char*);

struct PARM {
        long    from_flag;
        char    from[CHKLEN+1];
        long    dwg_flag;
        char    dwg[CHKLEN+1];
        long    id_flag;
        char    id[CHKLEN+1];
        long    type_flag;
        char    type[CHKLEN+1];
        long    type_opt;
        long    sho_flag;
        char    sho[CHKLEN+1];
        long    sho_opt;
        long    message_flag;
        char    message[CHKLEN+1];
};
static struct PARM PARM;

void    ac2userp(void)
{
    long    iflgar[3];
    long    ioutar[3];
    long    modear[3];
    char    vol[VOL_LEN+1];         /* Drive */
    char    group[GROUP_LEN+1];     /* Group */
    char    user[USER_LEN+1];       /* User */
    char    dwgid[DWGID_LEN+1];     /* DrawingID */
    long    eflag;
    short   ret;                    /* Return Code */

    /*--------------*/
    /* Initial      */
    /*--------------*/
    eflag = TRUE;
    memset(vol,   '\0', sizeof(vol));
    memset(group, '\0', sizeof(group));
    memset(user,  '\0', sizeof(user));
    memset(dwgid, '\0', sizeof(dwgid));
    PARM.from_flag = 0;
    PARM.dwg_flag = 0;
    PARM.id_flag = 0;
    PARM.type_flag = 0;
    PARM.sho_flag = 0;
    PARM.message_flag = 0;
    PARM.type_opt = -1;
    PARM.sho_opt = -1;

    /*--------------*/
    /* MC_bubegn    */
    /*--------------*/
    iflgar[0] = 52L;
    iflgar[1] = 0L;
    iflgar[2] = 2L;
    ret = MC_bubegn(10L, iflgar, ioutar, 10L);
    if (ret != 0) return;

    /*--------------*/
    /* MC_bumode    */
    /*--------------*/
    modear[0] = 2L;
    modear[1] = 0L;
    modear[2] = 12L;
    ret = MC_bumode(1L, modear, 10L);
    if (ret != 0) eflag = FALSE;

    if (eflag == TRUE) {
        /*--------------------------*/
        /* Check input parameters   */
        /*--------------------------*/
        ret = chkpara(vol, group, user, dwgid );
        if (ret != 0) {
            logmsg(ret);
            eflag = FALSE;
        }
    }
    if (eflag == TRUE) {
        /*--------------------------------------*/
        /* The process of erasing elements      */
        /*--------------------------------------*/
        ret = erselm(PARM.type_opt, PARM.sho_opt, vol, group, user, dwgid);
    }
    /*--------------------------------------*/
    /* Close the log file if necessary      */
    /*--------------------------------------*/
    logfclse();

    MC_buend(1L, 10L);
    return;
}
/************************************************************************
*                                                                       *
*   Check paramter and get vol, group, user, dwgid information          *
*   If necessary, open the log file                                     *
*                                                                       *
*       fvol    : Volume                                                *
*       fgrp    : Group                                                 *
*       fusr    : User                                                  *
*       fdwgid  : DrawingID                                             *
*                                                                       *
************************************************************************/
static  int chkpara(char *fvol, char *fgrp, char *fusr, char *fdwgid)
{
    int     ii, jj;
    int     len;
    int     mflg = 0;
    short   ret;
    char    keywd[CHKLEN+1];
    char   *kwd;
    char    userid[ID_LEN+1];
    char    password[ID_LEN+1];
    long    userid_mode=1;
    char   *pos;

    /*--------------------------*/
    /* Check input parameters   */
    /*--------------------------*/
    if (ACCARG.argc < 5) {
        return(INVALID_PARA);
    }

    /*--------------------------*/
    /* Check MSG parameters     */
    /*--------------------------*/
    ret = 0;
    for (ii = 1; ii < ACCARG.argc; ii++) {
        len = (int)strlen(ACCARG.argv[ii]);
        if (len == 0)
            break;
        if (len > CHKLEN)
            len = CHKLEN;
        strncpy(keywd, ACCARG.argv[ii], len);
        keywd[len] = '\0';

        kwd = strchr(keywd, '=');
        if (kwd == NULL) {
            ret = INVALID_PARA_MSG;
            break;
        }

        *kwd = '\0';
        kwd++;
        len = (int)strlen(keywd);
        for (jj = 0; jj < len; jj++) {
            keywd[jj] = (char)toupper((unsigned char)keywd[jj]);
            ACCARG.argv[ii][jj] = keywd[jj];
        }
        if (strcmp(keywd, "MSG") == 0 ||
            strcmp(keywd, "M") == 0) {
            len = (int)strlen(keywd);
            if (len > 49 || len < 1) {
                ret = INVALID_PARA_MSG;
                break;
            }
            if (PARM.message_flag == 1)
                break;
            /*--------------------------*/
            /* Open the log file        */
            /*--------------------------*/
            ret = logfopen(kwd);
            if (ret != 0) {
                return(1);
            }
            strcpy(PARM.message, kwd);
            len = (int)strlen(PARM.message);
            PARM.message_flag = 1;
        }
    }
    /*--------------------------*/
    /* Check each parameter     */
    /*--------------------------*/
    for (ii = 1; ii < ACCARG.argc; ii++) {
        len = (int)strlen(ACCARG.argv[ii]);
        if (len == 0)
            break;
        if (len > CHKLEN)
            len = CHKLEN;
        strncpy(keywd, ACCARG.argv[ii], len);
        keywd[len] = '\0';
        for (jj = 0; jj < len; jj++) {
            keywd[jj] = (char)toupper((unsigned char)keywd[jj]);
            ACCARG.argv[ii][jj] = keywd[jj];
        }
        /*--------------------------*/
        /* Check FROM parameter     */
        /*--------------------------*/
        if (strncmp(ACCARG.argv[ii], "FROM=", 5) == 0) {
            if ((int)strlen(ACCARG.argv[ii]+5) > 44) {
                ret = INVALID_PARA_FROM;
                break;
            }

            strcpy(PARM.from, ACCARG.argv[ii]+5);
            PARM.from_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "F=", 2) == 0) {
            if ((int)strlen(ACCARG.argv[ii]+2) > 44) {
                ret = INVALID_PARA_FROM;
                break;
            }
            strcpy(PARM.from, ACCARG.argv[ii]+2);
            PARM.from_flag = 1;
        }
        /*--------------------------*/
        /* Check DWG parameter      */
        /*--------------------------*/
        else if (strncmp(ACCARG.argv[ii], "DWG=", 4) == 0) {
            if ((int)strlen( ACCARG.argv[ii]+4 ) > DWG_LEN) {
                ret = INVALID_PARA_DWG;
                break;
            }
            strcpy(PARM.dwg, ACCARG.argv[ii]+4);
            PARM.dwg_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "D=", 2) == 0) {
            if ((int)strlen(ACCARG.argv[ii]+2) > DWG_LEN) {
                ret = INVALID_PARA_DWG;
                break;
            }
            strcpy(PARM.dwg, ACCARG.argv[ii]+2);
            PARM.dwg_flag = 1;
        }
        /*--------------------------*/
        /* Check ID parameter       */
        /*--------------------------*/
        else if (strncmp(ACCARG.argv[ii], "ID=", 3) == 0) {
            if ((int)strlen( ACCARG.argv[ii]+3 ) > 17) {
                ret = INVALID_PARA_ID;
                break;
            }
            strcpy(PARM.id, ACCARG.argv[ii]+3);
            PARM.id_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "I=", 2) == 0) {
            if ((int)strlen(ACCARG.argv[ii]+2) > 17) {
                ret = INVALID_PARA_ID;
                break;
            }
            strcpy(PARM.id, ACCARG.argv[ii]+2);
            PARM.id_flag = 1;
        }
        /*--------------------------*/
        /* Check TYPE parameter     */
        /*--------------------------*/
        else if (strncmp(ACCARG.argv[ii], "TYPE=", 5) == 0) {
            if ((int)strlen( ACCARG.argv[ii]+5 ) > 3) {
                ret = INVALID_PARA_TYPE;
                break;
            }
            strcpy(PARM.type, ACCARG.argv[ii]+5);
            PARM.type_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "T=", 2) == 0) {
            if ((int)strlen(ACCARG.argv[ii]+2) > 3) {
                ret = INVALID_PARA_TYPE;
                break;
            }
            strcpy(PARM.type, ACCARG.argv[ii]+2);
            PARM.type_flag = 1;
        }
        /*--------------------------*/
        /* Check SHO parameter      */
        /*--------------------------*/
        else if (strncmp(ACCARG.argv[ii], "SHO=", 4) == 0) {
            if ((int)strlen( ACCARG.argv[ii]+4 ) > 1) {
                ret = INVALID_PARA_SHO;
                break;
            }
            strcpy(PARM.sho, ACCARG.argv[ii]+4);
            PARM.sho_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "S=", 2) == 0) {
            if ((int)strlen(ACCARG.argv[ii]+2) > 1) {
                ret = INVALID_PARA_SHO;
                break;
            }
            strcpy(PARM.sho, ACCARG.argv[ii]+2);
            PARM.sho_flag = 1;
        }
    }

    if (ret == 0) {
        if (PARM.from_flag == 0 )      ret = INVALID_PARA_FROM_UNDEFINED;
        else if( PARM.dwg_flag == 0 )  ret = INVALID_PARA_DWG_UNDEFINED;
        else if( PARM.type_flag == 0 ) ret = INVALID_PARA_TYPE_UNDEFINED;
        else if( PARM.sho_flag == 0 )  ret = INVALID_PARA_SHO_UNDEFINED;
    }
    if (ret != 0) return(ret);

    /*-------------------------*/
    /* Check TYPE parameter    */
    /*-------------------------*/
    len = (int)strlen( PARM.type );
    if ( len != 1 && len != 3 ) {
        PARM.type_flag = 0;
        ret = INVALID_PARA_TYPE;
        return(ret);
    }
    if( strcmp(PARM.type, "A" ) == 0 ) {
        PARM.type_opt = 0;
        PARM.type_flag = 1;
    }
    else if( strcmp(PARM.type, "100" ) == 0 ) {
        PARM.type_opt = 100;
        PARM.type_flag = 1;
    }
    else {
        PARM.type_flag = 0;
        ret = INVALID_PARA_TYPE;
        return(ret);
    }

    /*------------------------*/
    /* Check SHO parameter    */
    /*------------------------*/
    len = (int)strlen( PARM.sho );
    if ( len != 1 ) {
        PARM.sho_flag = 0;
        ret = INVALID_PARA_SHO;
        return(ret);
    }
    if( strcmp(PARM.sho, "A" ) == 0 ) {
        PARM.sho_opt = 2;
        PARM.sho_flag = 1;
    }
    else if( strcmp(PARM.sho, "0" ) == 0 ) {
        PARM.sho_opt = 0;
        PARM.sho_flag = 1;
    }
    else {
        PARM.sho_flag = 0;
        ret = INVALID_PARA_SHO;
        return(ret);
    }

    /*----------------------------------------------*/
    /* Get vol, group and user from input string    */
    /*----------------------------------------------*/
    ret = brkpara(PARM.from, fvol, fgrp, fusr);
    if (ret != 0) return(ret);

    /*--------------------------*/
    /* Check DWG parameter      */
    /*--------------------------*/
    pos = strchr(PARM.dwg, ',');
    len = (int)strlen( PARM.dwg );
    if (pos == NULL) {        
        if( len < 1 || len > DWGID_LEN ) return( INVALID_PARA_DWG );
        memcpy(fdwgid, PARM.dwg, len);
        memset(&fdwgid[len], SPACE_CHAR, DWGID_LEN-len);
        fdwgid[DWGID_LEN] = '\0';

    }
    else {
        if( len < 1 ) return( INVALID_PARA_DWG );
        ret = MC_budwgn( 1L, fgrp, fusr, fdwgid, &len, PARM.dwg, 10L );
        if (ret != 0) return(INVALID_PARA_DWG);
    }

    /*------------------*/
    /* Get Logon UserID */
    /*------------------*/
    ret = MC_gtuid( userid );
    if( ret == 0 ) {
        userid_mode = 1;
        if( PARM.id_flag == 0 ) return( INVALID_PARA_ID_UNDEFINED );
        /*-------------------------------------------*/
        /* Get UserID, Password from input string    */
        /*-------------------------------------------*/
        ret = brkpara_id(PARM.id, userid, password);
        if (ret != 0) return(ret);
    }
    else if( ret == 1 ) { /* Not use UserID */
        userid_mode = 0;
    }

    /* Set UserID, password */
    if( userid_mode ) {
        ret = MC_usrid2( userid, password, fgrp, fusr );
        if (ret != 0) return(INVALID_PARA_ID);
    }
    return(0);
}
/************************************************************************
*                                                                       *
*   Get vol, group and user from input string                           *
*                                                                       *
*       buff    : Input string                                          *
*       fvol    : Volume                                                *
*       fgrp    : Group                                                 *
*       fusr    : User                                                  *
*                                                                       *
************************************************************************/
static  int brkpara(char *buff, char *fvol, char *fgrp, char *fusr)
{
    int     len;
    char    *grp;
    char    *usr;

    /*------------------------------*/
    /* Separate USER from string    */
    /*------------------------------*/
    fusr[0] = '\0';
    usr = strchr(buff, ',');
    if (usr != NULL) {
        *usr = '\0';
        usr++;
        len = (int)strlen(usr);
        if (len > USER_LEN || len < 1) {
            return(INVALID_PARA_FROM);
        }
        memcpy(fusr, usr, len);
        memset(&fusr[len], SPACE_CHAR, USER_LEN-len);
        fusr[USER_LEN] = '\0';
    }
    else {
        return(INVALID_PARA_FROM);
    }
    /*------------------------------*/
    /* Separate GROUP from string   */
    /*------------------------------*/
    grp = strchr(buff, ':');
    if (grp == NULL) {
        return(INVALID_PARA_FROM);
    }
    fgrp[0] = '\0';
    *grp = '\0';
    grp++;
    len = (int)strlen(grp);
    if (len > GROUP_LEN || len < 1) {
        return(INVALID_PARA_FROM);
    }
    memcpy(fgrp, grp, len);
    memset(&fgrp[len], SPACE_CHAR, GROUP_LEN-len);
    fgrp[GROUP_LEN] = '\0';
    /*------------------------------*/
    /* Separate VOL from string     */
    /*------------------------------*/
    len = (int)strlen(buff);
    if (len > VOL_LEN || len < 1) {
        return(INVALID_PARA_FROM);
    }
    memcpy(fvol, buff, len);
    memset(&fvol[len], SPACE_CHAR, VOL_LEN-len);
    fvol[VOL_LEN] = '\0';
    return(0);
}
/************************************************************************
*                                                                       *
*   Get userid, password from input string                              *
*                                                                       *
*       buff    : Input string                                          *
*       fvol    : UserID                                                *
*       fgrp    : Password                                              *
*                                                                       *
************************************************************************/
static  int brkpara_id(char *buff, char *userid, char *password)
{
    int     len;
    char    *pass;

    /*-----------------------------------*/
    /* Separate Passsword from string    */
    /*-----------------------------------*/
    password[0] = '\0';
    pass = strchr(buff, ',');
    if (pass != NULL) {
        *pass = '\0';
        pass++;
        len = (int)strlen(pass);
        if (len > ID_LEN || len < 1) {
            return(INVALID_PARA_ID);
        }
        memcpy(password, pass, len);
        memset(&password[len], SPACE_CHAR, ID_LEN-len);
        password[ID_LEN] = '\0';
    }
    else {
        return(INVALID_PARA_ID);
    }
    /*-------------------------------*/
    /* Separate UserID from string   */
    /*-------------------------------*/
    len = (int)strlen(buff);
    if (len > ID_LEN || len < 1) {
        return(INVALID_PARA_ID);
    }
    memcpy(userid, buff, len);
    memset(&userid[len], SPACE_CHAR, ID_LEN-len);
    userid[ID_LEN] = '\0';
    return(0);
}
